Bug 496629 - [RFE] Include fence_virsh along with the present agents
[RFE] Include fence_virsh along with the present agents
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: cman (Show other bugs)
5.4
All Linux
low Severity medium
: rc
: ---
Assigned To: Marek Grac
Cluster QE
: FutureFeature, TechPreview
: 516160 (view as bug list)
Depends On:
Blocks: RHEL5u4_relnotes
  Show dependency treegraph
 
Reported: 2009-04-20 08:57 EDT by Nigel Jones
Modified: 2016-04-26 10:03 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Technology Preview
Doc Text:
The fence_virsh fence agent is provided in this release of Red Hat Enterprise Linux as a Technology Preview. fence_virsh provides the ability for one guest (running as a domU) to fence another using the libvirt protocol. However, as fence_virsh is not integrated with cluster-suite it is not supported as a fence agent in that environment.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 07:10:17 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Nigel Jones 2009-04-20 08:57:29 EDT
Currently the git tree on Fedora Hosted has a fence_virsh option that is included with the latest packages in Fedora Rawhide.

I have personally tried these scripts under Red Hat Enterprise Linux 5.3 with great success and ease.  It would be nice to have these scripts included with Red Hat Enterprise Linux 5.4 (or a later version if it can't be 5.4).

The main things that the scripts have for it over fence_xvmd:
 * Easy to set up (1 line, plus an extra for each node)
 * Only requires SSH setup and working

I'm sure there are others I've missed but they are the main ones for me.
Comment 1 Nigel Jones 2009-04-20 09:41:38 EDT
Actually most likely the biggest advantage that fence_virsh has over fence_xvmd is that you don't need to install anything on the host, which means you can have say a Gentoo host machine or maybe a Debian host machine, and not have to install the cluster tools on the host to get it working - a nice extra thought.
Comment 2 Perry Myers 2009-04-21 14:03:50 EDT
I think there is value in including fence_virsh as per Comment #1.  Theoretically any system that supports libvirt could be used as a fence device for virtual machines.  (Perhaps fence_virsh could one day replace fence_vmware once libvirt supports vmware)

However, I think we should make it clear that fence_virsh does not provide the same level of functionality as fence_xvmd.  My understanding is that fence_virsh does not tie into the cluster running on the host node.  So we should recommend using fence_xvmd when cluster suite is being used on the host OS and the guest is being treated as a service managed by rgmanager.

But if cluster suite is not being run on the host OS (say in the case of using oVirt or RHEV which has a centralized mgmt server for fencing the physical hosts) then fence_virsh could be used as a lightweight fence agent that doesn't pull in all of the cluster infrastructure on the host.
Comment 3 Lon Hohberger 2009-04-21 16:57:28 EDT
So, I believe fence_virsh is not actually easier to
configure on a RHEL or Fedora system than fence_xvm[d].
Fence_virsh both requires more administrative steps and
more configuration information in order to operate in
the simplest case where fence_virsh is typically used.

Today, fence_xvmd will likely only run on Linux, and, as
stated, requires a fair bit of other software be installed
because of the way it is built.  In the absence of this 
software, you can't currently use fence_xvmd (even in 
single-node mode), though you can use fence_virsh.

It is easily possible to eliminate fence_xvmd's
dependencies on other software (and only link against
libvirt), but maybe not worth the effort since a solution
already exists (i.e. fence_virsh).

Fence_xvmd however is a new "daemon", for which we do not
have a separate init script today, which is kind of ugly.

Rgmanager managing VMs is a different issue and is
completely orthogonal to use of fence_xvmd or fence_virsh.

Whenever you are using VMs on a cluster of hosts where the
VMs are stored on shared storage (rgmanager or not; it
doesn't matter), using fence_virsh should not be supported.
It does not have previous knowledge of VM states and
locations and can not tie in correctly to the fencing
subsystem on the host cluster.

Adding these functions to fence_virsh would be
(a) substantially more work than removing run-time software
dependencies from fence_xvmd, and (b) make fence_virsh a
difficult piece of software to configure.

I.E. If we end up wanting one agent to serve both use cases
in the future, the answer is "remove runtime dependencies
from fence_xvmd and add an initscript", not "add cluster
support to fence_virsh".
Comment 4 Lon Hohberger 2009-04-21 17:02:39 EDT
BTW I should have said a "clustered file system", not
"shared storage".  I.e. anything which would normally
require fencing.
Comment 5 Lon Hohberger 2009-04-21 17:19:28 EDT
Also, administrators are probably more familiar with
ssh key distribution and so forth, so they may find it
easier to understand and configure despite the fact
that it requires more steps and information.
Comment 8 Perry Myers 2009-05-19 14:13:45 EDT
Release note added. If any revisions are required, please set the 
"requires_release_notes" flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

New Contents:
The fence_virsh fence agent is provided in this release of RHEL along side the other fence agents in the cman package.  fence_virsh provides the ability for one guest running as a domU in Xen or KVM guest to fence another using the libvirt protocol.  However, since fence_virsh is not integrated with cluster-suite it is not supported as a fence agent in that environment.  fence_virsh is considered Tech Preview for this release.
Comment 10 Ryan Lerch 2009-05-19 19:48:29 EDT
Release note updated. If any revisions are required, please set the 
"requires_release_notes"  flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

Diffed Contents:
@@ -1 +1 @@
-The fence_virsh fence agent is provided in this release of RHEL along side the other fence agents in the cman package.  fence_virsh provides the ability for one guest running as a domU in Xen or KVM guest to fence another using the libvirt protocol.  However, since fence_virsh is not integrated with cluster-suite it is not supported as a fence agent in that environment.  fence_virsh is considered Tech Preview for this release.+The fence_virsh fence agent is provided in this release of Red Hat Enterprise Linux as a Technology Preview. fence_virsh provides the ability for one guest (running as a domU) to fence another using the libvirt protocol. However, as fence_virsh is not integrated with cluster-suite it is not supported as a fence agent in that environment.
Comment 11 Marek Grac 2009-05-21 08:26:17 EDT
Fencing agent from #472785 (rawhide) was modified to work with older version of fencing library.
Comment 15 Perry Myers 2009-08-07 08:28:46 EDT
*** Bug 516160 has been marked as a duplicate of this bug. ***
Comment 16 errata-xmlrpc 2009-09-02 07:10:17 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1341.html

Note You need to log in before you can comment on or make changes to this bug.